$regfile = "89c2051.dat"
$crystal = 11059200
$baud = 9600
Config Lcdpin = Pin , Db4 = P1.7 , Db5 = P1.6 , Db6 = P1.5 , Db7 = P1.4 , E = P1.3 , Rs = P1.2
Config Lcd = 16 * 1a
Config 1wire = P1.0

Dim Bd(8) As Byte
Dim Tmp As Byte
Dim T As Integer
Dim T1 As Integer , T2 As Integer
Dim Nowy As Bit
Dim Kom As Byte , Adr As Byte
Reset Tcon.0

On Int0 Rc5
Declare Sub Silnik_start
Declare Sub Silnik_stop
Declare Sub Wlacz_grzanie
Declare Sub Wlacz_chlodzenie
Declare Sub Wylacz
Declare Sub Temperatura
Enable Int0
Enable Interrupts

Kom = 13
Nowy = 1
Call Silnik_stop

Do
   If Nowy = 1 Then
      Disable Int0
      Nowy = 0
      Cls
      Lcd "AD= " ; Adr ; " KOM=" ; Kom
      If Kom = 14 Then Call Silnik_start
      If Kom = 19 Then Call Silnik_stop
      If Kom = 11 Then Call Wlacz_grzanie
      If Kom = 13 Then Call Wylacz
      If Kom = 12 Then Call Wlacz_chlodzenie
      Waitms 250
      Enable Int0
   Else
      Call Temperatura
      Tmp = T / 10
      T = T Mod 10
      Print "T= " ; Tmp ; "." ; T ; " " ; Chr(176) ; "C"
   End If
Loop

Rc5:
Getrc5(adr , Kom)
Nowy = 1
Return

Sub Silnik_start
   Set P3.7
   Print "silnik Wlaczony"
End Sub

Sub Silnik_stop
   Reset P3.7
   Print "Silnik Wylaczony"
End Sub

Sub Wlacz_grzanie
   Reset P3.4
   Set P3.5
   Print "Grzanie Wlaczone"
End Sub

Sub Wlacz_chlodzenie
   Set P3.4
   Reset P3.5
   Print "chlodzenie Wlaczone"
End Sub

Sub Wylacz
   Set P3.4
   Set P3.5
   Print "Uklad Grzania/Chlodzenia Wylaczony"
End Sub

Sub Temperatura
   1wreset
   1wwrite &HCC
   1wwrite &H44
   Waitms 255
   Waitms 255
   1wreset
   1wwrite &HCC
   1wwrite &HBE
   Bd(1) = 1wread(8)
   1wreset
   Tmp = Bd(1) And 1
    If Tmp = 1 Then Decr Bd(1)
     T1 = Makeint(bd(1) , Bd(2))
     T1 = T1 * 50
     T1 = T1 - 25
     T2 = Bd(8) - Bd(7)
     T2 = T2 * 100
     T2 = T2 / Bd(8)
     T1 = T1 + T2
     T = T1 / 10
End Sub