$regfile = "89c2051.dat"
Config Lcdpin = Pin , Db4 = P1.7 , Db5 = P1.6 , Db6 = P1.5 , Db7 = P1.4 , E = P1.3 , Rs = P1.2
Config Lcd = 16 * 1a


Config Scl = P3.5
Config Sda = P3.7
Const Pcf8583w = 160
Const Pcf8583r = 161


Dim S As Byte
Dim M As Byte
Dim G As Byte


Declare Sub Ustaw_czas(g As Byte , M As Byte , S As Byte)
Declare Sub Odczytaj_czas


Set Tcon.0

Enable Int0
Enable Interrupts
On Int0 Int0_odczyt
Cls
Cursor Off
Call Ustaw_czas(8 , 35 , 20)
Do


Loop


Int0_odczyt:
   Call Odczytaj_czas
   Home
   Lcd Bcd(g) ; ":" ; Bcd(m) ; ":" ; Bcd(s)
Return

Sub Ustaw_czas(g As Byte , M As Byte , S As Byte)
   G = Makebcd(g)
   M = Makebcd(m)
   S = Makebcd(s)

   I2cstart
   I2cwbyte Pcf8583w
   I2cwbyte 0
   I2cwbyte 8
   I2cstart
   I2cwbyte Pcf8583w
   I2cwbyte 2
   I2cwbyte S
   I2cwbyte M
   I2cwbyte G
   I2cstop
   Waitms 10
End Sub


Sub Odczytaj_czas
   I2cstart
   I2cwbyte Pcf8583w
   I2cwbyte 2
   I2cstart
   I2cwbyte Pcf8583r
   I2crbyte S , Ack
   I2crbyte M , Ack
   I2crbyte G , Nack
   I2cstop
   Waitms 10
End Sub