$regfile = "89c2051.dat"

Config Scl = P3.5
Config Sda = P3.7
Const Pcf8574w = 112
Const Pcf8574r = 113



Const Maxkrok = 4
Declare Sub Silnik

On Int0 Obsluga_s1
On Int1 Obsluga_s2
Enable Interrupts
Enable Int0
Enable Int1


Dim Nrkroku As Byte
Dim Krok(4) As Byte
Dim Kierunek As Byte
Kierunek = 0
Krok(1) = &B00010001
Krok(2) = &B00100010
Krok(3) = &B01000100
Krok(4) = &B10001000
Nrkroku = 1


Do
   Call Silnik
   Waitms 250
Loop

Sub Silnik
  If Kierunek = 1 Then
   I2csend Pcf8574w , Krok(nrkroku)
   Incr Nrkroku
   If Nrkroku > Maxkrok Then Nrkroku = 1
  Elseif Kierunek = 2 Then
   I2csend Pcf8574w , Krok(nrkroku)
   Decr Nrkroku
   If Nrkroku = 0 Then Nrkroku = Maxkrok
  End If
End Sub

Obsluga_s1:
   Disable Int0
   If Kierunek = 1 Then Kierunek = 0 Else Kierunek = 1
   Waitms 50
   Enable Int0
Return

Obsluga_s2:
   Disable Int1
   If Kierunek = 2 Then Kierunek = 0 Else Kierunek = 2
   Waitms 50
   Enable Int1
Return

