$regfile = "89c2051.dat"
Config Lcdpin = Pin , Db4 = P1.7 , Db5 = P1.6 , Db6 = P1.5 , Db7 = P1.4 , E = P1.3 , Rs = P1.2
Config Lcd = 16 * 1a

Config Scl = P3.5
Config Sda = P3.7
Const 24c08w = 168
Const 24c08r = 169


Dim Pom As Byte
Dim Adres_danej As Byte
Dim Dana As Byte
Dim I As Byte


Declare Sub Write_eeprom(adres_danej As Byte , Dana As Byte)
Declare Sub Read_eeprom(adres_danej As Byte , Dana As Byte)


Cls
Lcd "Kasowan. AT24C08"
For I = 0 To 255
   Call Write_eeprom(i , &B11111111)
Next I



Cls
Lcd "Zapis do At24c08"
For I = 0 To 255
   Pom = Rnd(255)
   Call Write_eeprom(i , Pom)
Next I


Cls
Lcd "Odczyt z At24c08"
Wait 1
For I = 0 To 255
   Cls
   Call Read_eeprom(i , Dana)
   Lcd "adr= " ; I ; " D= " ; Dana
   Waitms 255
   Waitms 255
Next I
End


Sub Write_eeprom(adres_danej As Byte , Dana As Byte)
   I2cstart
   I2cwbyte 24c08w
   I2cwbyte Adres_danej
   I2cwbyte Dana
   I2cstop
   Waitms 10
End Sub


Sub Read_eeprom(adres_danej As Byte , Dana As Byte)
   I2cstart
   I2cwbyte 24c08w
   I2cwbyte Adres_danej
   I2cstart
   I2cwbyte 24c08r
   I2crbyte Dana , Nack
   I2cstop
   Waitms 10
End Sub